//+------------------------------------------------------------------+
//|                                                    mfi color mtf |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  Lime
#property indicator_color2  Red
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern ENUM_TIMEFRAMES TimeFrame       = PERIOD_CURRENT;
extern double          MfiPeriod       = 14;
extern double          T3Hot           = 1.0;
extern bool            T3Original      = false;
extern bool            alertsOn        = true;
extern bool            alertsOnCurrent = false;
extern bool            alertsMessage   = true;
extern bool            alertsSound     = false;
extern bool            alertsNotify    = false;
extern bool            alertsEmail     = false;
extern string          soundFile       = "alert2.wav";

//
//
//
//
//

double mfi[];
double mfiUa[];
double mfiUb[];
double slope[];
string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
  {
   IndicatorBuffers(4);
   SetIndexBuffer(0,mfiUa); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,mfiUb); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,mfi);
   SetIndexBuffer(3,slope);
   
   //
   //
   //
   //
   //
    
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame==-99;
   TimeFrame         = MathMax(TimeFrame,_Period);
      
   //
   //
   //
   //
   //
   
   IndicatorShortName(timeFrameToString(TimeFrame)+ "  T3 Mfi ");
   return(0);
}
int deinit(){ return(0);}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1); 
           if (returnBars)  { mfiUa[0] = limit+1; return(0); }
   
   //
   //
   //
   //
   //
   
   if (TimeFrame == Period())
   {
     for(i=limit; i>=0; i--)
     {  
        double PosMF = 0.0;
        double NegMF = 0.0;
        double CurTP = (High[i]+Low[i]+Close[i])/3;
        double PreTP = (High[i+1]+Low[i+1]+Close[i+1])/3;   
      
        for(int j=0; j < MfiPeriod; j++)
        {
         
          if(CurTP > PreTP) PosMF += Volume[i+j]*CurTP;  
          else
          {
          if(CurTP < PreTP) NegMF += Volume[i+j]*CurTP;
          }
           CurTP = PreTP;      
        }
         
        //
        //
        //
        //
        //
      
        if(NegMF  != 0.0)      
             mfi[i]  = iT3(100*(PosMF/NegMF),MfiPeriod,T3Hot,T3Original,i);
        else mfi[i]  = iT3(100,              MfiPeriod,T3Hot,T3Original,i); 
    
        mfiUa[i] = EMPTY_VALUE;
        mfiUb[i] = EMPTY_VALUE;
        slope[i] = slope[i+1];
        if (mfi[i] > mfi[i+1]) slope[i] =  1;
        if (mfi[i] < mfi[i+1]) slope[i] = -1;
        if (slope[i]== 1) mfiUa[i] = 1;
        if (slope[i]==-1) mfiUb[i] = 1;
      }
      
      //
      //
      //
      //
      //
      
      if (alertsOn)
      {
        if (alertsOnCurrent)
             int whichBar = 0;
        else     whichBar = 1; 
        if (slope[whichBar] != slope[whichBar+1])
        {
           if (slope[whichBar] ==  1) doAlert(whichBar,"up");
           if (slope[whichBar] == -1) doAlert(whichBar,"down");
        }
      }
      return(0);
      }
     
      //
      //
      //
      //
      //
   
      limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
      for(i=limit; i>=0; i--)
      {  
         int y = iBarShift(NULL,TimeFrame,Time[i]);
            slope[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,MfiPeriod,T3Hot,T3Original,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,3,y);
            mfiUa[i] = EMPTY_VALUE;
            mfiUb[i] = EMPTY_VALUE; 
            if (slope[i]== 1) mfiUa[i] = 1;
            if (slope[i]==-1) mfiUb[i] = 1; 
       }
return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//
//
//
//

double workT3[][6];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5

//
//
//
//
//

double iT3(double price, double period, double hot, bool original, int i, int forInstance=0)
{
   if (ArrayRange(workT3,0) !=Bars)                  ArrayResize(workT3,Bars);
   if (ArrayRange(workT3Coeffs,0) < (forInstance+1)) ArrayResize(workT3Coeffs,forInstance+1);

   if (workT3Coeffs[forInstance][_period] != period)
   {
     workT3Coeffs[forInstance][_period] = period;
        double a = hot;
            workT3Coeffs[forInstance][_c1] = -a*a*a;
            workT3Coeffs[forInstance][_c2] = 3*a*a+3*a*a*a;
            workT3Coeffs[forInstance][_c3] = -6*a*a-3*a-3*a*a*a;
            workT3Coeffs[forInstance][_c4] = 1+3*a+a*a*a+3*a*a;
            if (original)
                 workT3Coeffs[forInstance][_alpha] = 2.0/(1.0 + period);
            else workT3Coeffs[forInstance][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
   }
   
   //
   //
   //
   //
   //
   
   int buffer = forInstance*6;
   int r = Bars-i-1;
   if (r == 0)
      {
         workT3[r][0+buffer] = price;
         workT3[r][1+buffer] = price;
         workT3[r][2+buffer] = price;
         workT3[r][3+buffer] = price;
         workT3[r][4+buffer] = price;
         workT3[r][5+buffer] = price;
      }
   else
      {
         workT3[r][0+buffer] = workT3[r-1][0+buffer]+workT3Coeffs[forInstance][_alpha]*(price              -workT3[r-1][0+buffer]);
         workT3[r][1+buffer] = workT3[r-1][1+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][0+buffer]-workT3[r-1][1+buffer]);
         workT3[r][2+buffer] = workT3[r-1][2+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][1+buffer]-workT3[r-1][2+buffer]);
         workT3[r][3+buffer] = workT3[r-1][3+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][2+buffer]-workT3[r-1][3+buffer]);
         workT3[r][4+buffer] = workT3[r-1][4+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][3+buffer]-workT3[r-1][4+buffer]);
         workT3[r][5+buffer] = workT3[r-1][5+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][4+buffer]-workT3[r-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[forInstance][_c1]*workT3[r][5+buffer] + 
          workT3Coeffs[forInstance][_c2]*workT3[r][4+buffer] + 
          workT3Coeffs[forInstance][_c3]*workT3[r][3+buffer] + 
          workT3Coeffs[forInstance][_c4]*workT3[r][2+buffer]);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

           message =  StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Money Flow Index changed direction to ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(), Period(), " Money Flow Index "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}




  